from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, File, Float, Directory

Velvetg_V0_1_0 = CommandToolBuilder(tool="velvetg", base_command=["velvetg"], inputs=[ToolInput(tag="in_cov_cut_off", input_type=String(optional=True), prefix="-cov_cutoff", doc=InputDocumentation(doc=": removal of low coverage nodes AFTER tour bus or allow the system to infer it\n(default: no removal)")), ToolInput(tag="in_ins_length", input_type=Int(optional=True), prefix="-ins_length", doc=InputDocumentation(doc=": expected distance between two paired end reads (default: no read pairing)")), ToolInput(tag="in_read_tr_kg", input_type=String(optional=True), prefix="-read_trkg", doc=InputDocumentation(doc=": tracking of short read positions in assembly (default: no tracking)")), ToolInput(tag="in_min_contig_lgth", input_type=Int(optional=True), prefix="-min_contig_lgth", doc=InputDocumentation(doc=": minimum contig length exported to contigs.fa file (default: hash length * 2)")), ToolInput(tag="in_amos_file", input_type=File(optional=True), prefix="-amos_file", doc=InputDocumentation(doc=": export assembly to AMOS file (default: no export)")), ToolInput(tag="in_exp_cov", input_type=String(optional=True), prefix="-exp_cov", doc=InputDocumentation(doc=": expected coverage of unique regions or allow the system to infer it\n(default: no long or paired-end read resolution)")), ToolInput(tag="in_ins_length_two", input_type=Int(optional=True), prefix="-ins_length2", doc=InputDocumentation(doc=": expected distance between two paired-end reads in the second short-read dataset (default: no read pairing)")), ToolInput(tag="in_ins_length_long", input_type=Int(optional=True), prefix="-ins_length_long", doc=InputDocumentation(doc=": expected distance between two long paired-end reads (default: no read pairing)")), ToolInput(tag="in_scaffolding", input_type=String(optional=True), prefix="-scaffolding", doc=InputDocumentation(doc=": scaffolding of contigs used paired end information (default: on)")), ToolInput(tag="in_max_branch_length", input_type=Int(optional=True), prefix="-max_branch_length", doc=InputDocumentation(doc=": maximum length in base pair of bubble (default: 100)")), ToolInput(tag="in_max_divergence", input_type=Float(optional=True), prefix="-max_divergence", doc=InputDocumentation(doc=": maximum divergence rate between two branches in a bubble (default: 0.2)")), ToolInput(tag="in_max_gap_count", input_type=Int(optional=True), prefix="-max_gap_count", doc=InputDocumentation(doc=": maximum number of gaps allowed in the alignment of the two branches of a bubble (default: 3)")), ToolInput(tag="in_min_pair_count", input_type=Int(optional=True), prefix="-min_pair_count", doc=InputDocumentation(doc=": minimum number of paired end connections to justify the scaffolding of two long contigs (default: 10)")), ToolInput(tag="in_max_coverage", input_type=String(optional=True), prefix="-max_coverage", doc=InputDocumentation(doc=": removal of high coverage nodes AFTER tour bus (default: no removal)")), ToolInput(tag="in_long_mult_cut_off", input_type=Int(optional=True), prefix="-long_mult_cutoff", doc=InputDocumentation(doc=": minimum number of long reads required to merge contigs (default: 2)")), ToolInput(tag="in_unused_reads", input_type=File(optional=True), prefix="-unused_reads", doc=InputDocumentation(doc=": export unused reads in UnusedReads.fa file (default: no)")), ToolInput(tag="in_directory", input_type=Directory(), position=0, doc=InputDocumentation(doc=": working directory name"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Velvetg_V0_1_0().translate("wdl", allow_empty_container=True)

